//+------------------------------------------------------------------+
//|                                                 correlations.mq4 |
//|                                                           mladen |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      "mladenfx@gmail.com"

#property indicator_separate_window
#property indicator_buffers    8
#property indicator_level1     0
#property indicator_levelcolor DimGray

//
//
//
//
//

#import "correlations.dll"
   double Pearson(double& arrayA[], int isSeriesA, double& arrayB[], int isSeriesB, int bars, int shift, int length,int returnValue);
   double Kendall(double& arrayA[], int isSeriesA, double& arrayB[], int isSeriesB, int bars, int shift, int length,int returnValue);
   double Spearman(double& arrayA[], int isSeriesA, double& arrayB[], int isSeriesB, int bars, int shift, int length,int returnValue);
#import

//
//
//
//
//

extern string _           = "parameters";
extern string Symbols     = "EURJPY;EURUSD;EURCHF;GBPJPY;GBPUSD;USDJPY;USDCAD;USDCHF";
extern int    Length      = 50;
extern int    Price       = PRICE_CLOSE;
extern int    Type        = 0;
extern int    SubType     = 0;
extern color  colorFrom   = LimeGreen;
extern color  colorMiddle = Gold;
extern color  colorTo     = MediumVioletRed;
extern int    linesWidth  = 0;

//
//
//
//
//

double buffer1[];
double buffer2[];
double buffer3[];
double buffer4[];
double buffer5[];
double buffer6[];
double buffer7[];
double buffer8[];
string aPairs[];
string sPairs[];

double prices0[];
double prices1[];
double prices2[];
double prices3[];
double prices4[];
double prices5[];
double prices6[];
double prices7[];
double prices8[];

//
//
//
//
//

int    totalSymbols;
string IndicatorFileName;
bool   gettingBars = false;
string prefix      = "NA";
string suffix      = "NA";
string shortName;
string labelName;
string indName;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   SetIndexBuffer(0,buffer1);
      if (_=="gettingBars")
      {
         gettingBars = true;
         return(0);
      }

      //
      //
      //
      //
      //
      
                                 SetIndexStyle(0,DRAW_LINE,EMPTY,linesWidth,gradientColor(0,4,colorFrom,colorMiddle));
      SetIndexBuffer(1,buffer2); SetIndexStyle(1,DRAW_LINE,EMPTY,linesWidth,gradientColor(1,4,colorFrom,colorMiddle));
      SetIndexBuffer(2,buffer3); SetIndexStyle(2,DRAW_LINE,EMPTY,linesWidth,gradientColor(2,4,colorFrom,colorMiddle));
      SetIndexBuffer(3,buffer4); SetIndexStyle(3,DRAW_LINE,EMPTY,linesWidth,gradientColor(3,4,colorFrom,colorMiddle));
      SetIndexBuffer(4,buffer5); SetIndexStyle(4,DRAW_LINE,EMPTY,linesWidth,gradientColor(1,5,colorMiddle,colorTo));
      SetIndexBuffer(5,buffer6); SetIndexStyle(5,DRAW_LINE,EMPTY,linesWidth,gradientColor(2,5,colorMiddle,colorTo));
      SetIndexBuffer(6,buffer7); SetIndexStyle(6,DRAW_LINE,EMPTY,linesWidth,gradientColor(3,5,colorMiddle,colorTo));
      SetIndexBuffer(7,buffer8); SetIndexStyle(7,DRAW_LINE,EMPTY,linesWidth,gradientColor(4,5,colorMiddle,colorTo));

      //
      //
      //
      //
      //
      
      string subNameF = "";
      string subNameS = "";
      switch (Type)
      {
         case 0:
            indName = "Pearson ";
               switch (SubType)
               {
                  case 0:                           break;
                  case 1: subNameF = "fisher of ";  break;
                  case 2: subNameS = "Students t "; break;
               }
               break;
         case 1:
            indName = "Kendall\'s tau ";
               switch (SubType)
               {
                  case 0:                           break;
                  case 1: subNameF = "fisher of ";  break;
                  case 2: subNameS = "Students t "; break;
                  case 3: subNameS = "deviations ";  break;
               }
               break;
         case 2:
            indName = "Spearman\'s rank ";
               switch (SubType)
               {
                  case 1: subNameF = "fisher of ";                  break;
                  case 2: subNameS = "Students t ";                 break;
                  case 3: subNameS = "differences ";                break;
                  case 4: subNameS = "expectation of differences "; break;
                  case 5: subNameS = "deviations of differences ";  break;
               }
               break;
      }
      labelName = indName;
      indName   = subNameF+ indName + subNameS;
      
      //
      //
      //
      //
      //
      
   IndicatorFileName = WindowExpertName();
   shortName         = MakeUniqueName(indName," ("+Length+","+SubType+")");
   IndicatorShortName(shortName);
   return(0);
}

//
//
//
//
//

int deinit()
{
   for (int i=0;i<8;i++) ObjectDelete(shortName+i);
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,r,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
      
   //
   //
   //
   //
   //

      if (gettingBars) { buffer1[0] = limit; return(0); }
      if (suffix=="NA" || prefix=="NA")
      {
         getPrefixSuffix(prefix,suffix);
         Symbols = StringUpperCase(StringTrimLeft(StringTrimRight(Symbols)));
         if (StringSubstr(Symbols,StringLen(Symbols),1) != ";")
                          Symbols = StringConcatenate(Symbols,";");
     
         //
         //
         //
         //
         //

         int  s = 0; i = StringFind(Symbols,";",s);
         string current;
            while (i > 0)
            {
               current = StringSubstr(Symbols,s,i-s);
               if (findSymbol(prefix+current+suffix) && Symbol()!=(prefix+current+suffix)) 
               {
                  ArrayResize(aPairs,ArraySize(aPairs)+1);
                              aPairs[ArraySize(aPairs)-1] = current;
               }                        
               s = i + 1;
               i = StringFind(Symbols,";",s);
            }
         totalSymbols = MathMin(ArraySize(aPairs),8);
      
         //
         //
         //
         //
         //
      
         ArrayResize(sPairs,totalSymbols);
         for (i=0; i<totalSymbols; i++)
         {
            SetIndexLabel(i,labelName+" "+aPairs[i]);
            sPairs[i] = prefix+aPairs[i]+suffix;
         }         
      }      

      //
      //
      //
      //
      //
   
      if (ArrayRange(prices0,0) != Bars)
      {
         ArrayResize(prices0,Bars);
         ArrayResize(prices1,Bars);
         ArrayResize(prices2,Bars);
         ArrayResize(prices3,Bars);
         ArrayResize(prices4,Bars);
         ArrayResize(prices5,Bars);
         ArrayResize(prices6,Bars);
         ArrayResize(prices7,Bars);
         ArrayResize(prices8,Bars);
      }      

      //
      //
      //
      //
      //
         
      int window = WindowFind(shortName);
      for (i=0; i<totalSymbols;i++)
      {
         limit = MathMax(limit,MathMin(Bars-1,iCustom(sPairs[i],0,IndicatorFileName,"gettingBars",0,0)));
         if (ObjectFind(shortName+i) == -1)
         {
               ObjectCreate(shortName+i,OBJ_LABEL,window,0,0);
                  ObjectSet(shortName+i,OBJPROP_XDISTANCE,10);
                  ObjectSet(shortName+i,OBJPROP_YDISTANCE,10+i*14);
                  ObjectSet(shortName+i,OBJPROP_CORNER,1);
                  
                  color theColor;
                  switch(i)
                  {
                     case 0: theColor = gradientColor(0,4,colorFrom,colorMiddle); break;
                     case 1: theColor = gradientColor(1,4,colorFrom,colorMiddle); break;
                     case 2: theColor = gradientColor(2,4,colorFrom,colorMiddle); break;
                     case 3: theColor = gradientColor(3,4,colorFrom,colorMiddle); break;
                     case 4: theColor = gradientColor(1,5,colorMiddle,colorTo);   break;
                     case 5: theColor = gradientColor(2,5,colorMiddle,colorTo);   break;
                     case 6: theColor = gradientColor(3,5,colorMiddle,colorTo);   break;
                     case 7: theColor = gradientColor(4,5,colorMiddle,colorTo);   break;
                  }
                  ObjectSetText(shortName+i,aPairs[i],10,"Courier new bold",theColor);
            }
      }            

   //
   //
   //
   //
   //
            
   for(i=limit, r=Bars-limit-1; i>=0; i--,r++)
   {
      prices0[r] = iMA(NULL,0,1,0,MODE_SMA,Price,i);
      if (totalSymbols>0) { prices1[r] = getPrice(sPairs[0],Price,i); buffer1[i] = getValue(prices1,i); }
      if (totalSymbols>1) { prices2[r] = getPrice(sPairs[1],Price,i); buffer2[i] = getValue(prices2,i); }
      if (totalSymbols>2) { prices3[r] = getPrice(sPairs[2],Price,i); buffer3[i] = getValue(prices3,i); }
      if (totalSymbols>3) { prices4[r] = getPrice(sPairs[3],Price,i); buffer4[i] = getValue(prices4,i); }
      if (totalSymbols>4) { prices5[r] = getPrice(sPairs[4],Price,i); buffer5[i] = getValue(prices5,i); }
      if (totalSymbols>5) { prices6[r] = getPrice(sPairs[5],Price,i); buffer6[i] = getValue(prices6,i); }
      if (totalSymbols>6) { prices7[r] = getPrice(sPairs[6],Price,i); buffer7[i] = getValue(prices7,i); }
      if (totalSymbols>7) { prices8[r] = getPrice(sPairs[7],Price,i); buffer8[i] = getValue(prices8,i); }
   }                           
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

double getPrice(string symbol, int type, int i)
{
   if (StringFind(symbol,"USDX")>-1)
         return(usdIndex(type,i));
   else  return(iMA(symbol,0,1,0,MODE_SMA,type,i));
}
double getValue(double& prices[],int i)
{
   switch(Type)
   {
      case 0: return(Pearson(prices0,false,prices,false,Bars,i,Length,SubType));
      case 1: return(Kendall(prices0,false,prices,false,Bars,i,Length,SubType));
      case 2: return(Spearman(prices0,false,prices,false,Bars,i,Length,SubType));
   }
   return(0);
}
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

string MakeUniqueName(string first, string rest)
{
   string result = first+(MathRand()%1001)+rest;

   while (WindowFind(result)> 0)
          result = first+(MathRand()%1001)+rest;
   return(result);
}

//
//
//
//
//
string StringUpperCase(string str)
{
   string   s = str;
   int      lenght = StringLen(str) - 1;
   int      char;
   
   while(lenght >= 0)
      {
         char = StringGetChar(s, lenght);
         
         //
         //
         //
         //
         //
         
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                  s = StringSetChar(s, lenght, char - 32);
          else 
              if(char > -33 && char < 0)
                  s = StringSetChar(s, lenght, char + 224);
         lenght--;
   }
   return(s);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

string USDXsymbols[] = {"EURUSD","USDJPY","GBPUSD","USDCAD","USDSEK","USDCHF"};  
double USDXweights[] = {-0.576,-0.136,-0.119,-0.091,-0.042,-0.036};
bool   USDXdivide[]  = {false,true,false,true,true,true};

//
//
//
//
//

double usdIndex(int priceType, int i)
{
   bool   error   = false;   
   double product = 1.0;

   //
   //
   //
   //
   //
   
      for (int k=0; k<6 && !error; k++)
      {
         double price = iMA(prefix+USDXsymbols[k]+suffix,0,1,0,MODE_SMA,priceType,i);
         double value = 0.00;
   
         error = (price==0);
            if (!error)
            {
               if (USDXdivide[k])
                    value = 1/price;
               else value =   price;
               product *= MathPow(value,USDXweights[k]);
            }
      }
   
   //
   //
   //
   //
   //
   
   if (error)
         return(0);
   else  return(product*50.14348112);    
}


//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

#import "kernel32.dll"
    int _lclose (int);
    int _lopen  (string,int);
    int _llseek (int,int,int);
    int _lread  (int,string,int);
#import
#define sectorSize  1936
#define HFILE_ERROR -1
string  symbols[];

//
//
//
//
//

void getSymbolsList()
{
   ArrayResize(symbols,0);
   int fileHandle = _lopen(TerminalPath()+"\\history\\"+AccountServer()+"\\symbols.raw",0);
   if (fileHandle == HFILE_ERROR) return;
    
   //
   //
   //
   //
   //

   for(int i=0;; i++)
   {
      _llseek(fileHandle, i * sectorSize, 0);
      string symbolName = "123456789012";       
                        if (_lread (fileHandle, symbolName, 12) != 12) break;
             symbolName = StringSubstr(symbolName, 0);

             //
             //
             //
             //
             //

      ArrayResize(symbols,i+1); symbols[i] = StringTrimLeft(StringTrimRight(symbolName));
   } 
   _lclose(fileHandle);
}

//
//
//
//
//

bool findSymbol(string findWhat)
{
   if (StringFind(findWhat,"USDX")>-1) return(true);
   int  limit = ArraySize(symbols);
         for(int i=0; i<limit; i++) if (findWhat==symbols[i]) break;
   return(i<limit);      
}
void getPrefixSuffix(string& prefix, string& suffix)
{ 
   getSymbolsList();   
   int limit = ArraySize(symbols);
   if (limit<1) return;
         prefix="";
         suffix="";
   
   //
   //
   //
   //
   //
   
   for(int i=0; i<limit; i++)
   {
      string symbolName = symbols[i];
             int pos = StringFind(symbolName,"EURUSD",0);
             if (pos > -1)
             {
                if (pos>0)                         prefix = StringSubstr(symbolName,0,pos);
                if ((pos+6)<StringLen(symbolName)) suffix = StringSubstr(symbolName,(pos+6),0);
                break;
             }
   } 
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

color gradientColor(int step, int totalSteps, color from, color to)
{
   color newBlue  = getColor(step,totalSteps,(from & 0XFF0000)>>16,(to & 0XFF0000)>>16)<<16;
   color newGreen = getColor(step,totalSteps,(from & 0X00FF00)>> 8,(to & 0X00FF00)>> 8) <<8;
   color newRed   = getColor(step,totalSteps,(from & 0X0000FF)    ,(to & 0X0000FF)    )    ;
   return(newBlue+newGreen+newRed);
}
color getColor(int stepNo, int totalSteps, color from, color to)
{
   double step = (from-to)/(totalSteps-1.0);
   return(MathRound(from-step*stepNo));
}